function hsv_arr = sp_find_HSV_grid(I, grid_x, grid_y, patch_size)

% parameters
Ihsv =   colorspace('rgb->hsv',I);
colorFeaNum = 3;
 
num_patches = numel(grid_x);

hsv_arr = zeros(num_patches, colorFeaNum);


% for all patches
for ii=1:num_patches
    
    x_lo = grid_x(ii);
    x_hi = grid_x(ii) + patch_size - 1;
    y_lo = grid_y(ii);
    y_hi = grid_y(ii) + patch_size - 1;
    
    hsv_arr(ii,1) = mean(mean(Ihsv(y_lo:y_hi,x_lo:x_hi,1)));
    hsv_arr(ii,2) = mean(mean(Ihsv(y_lo:y_hi,x_lo:x_hi,2)));
    hsv_arr(ii,3) = mean(mean(Ihsv(y_lo:y_hi,x_lo:x_hi,3)));
    
end
 